You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

1316 line
30 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __lf=$'\n'
  21. __cr=$'\r'
  22. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  23. mkdir -p "$TMP"
  24. __homerun="$HOME/.var/run"
  25. mkdir -p "$__homerun"
  26. ##########################
  27. # system type
  28. gnu_coreutils=false # for mac
  29. null ls --version && gnu_coreutils=true
  30. inbash=false
  31. inzsh=false
  32. if test -n "$BASH_VERSION"
  33. then
  34. inbash=true
  35. elif test -n "$ZSH_VERSION"
  36. then
  37. inzsh=true
  38. fi
  39. #################################
  40. # file pathes:
  41. # shrc: Path to this file
  42. if $inbash
  43. then
  44. __shrc="$BASH_SOURCE"
  45. elif $inzsh
  46. then
  47. __shrc="$0"
  48. fi
  49. #########################
  50. # system detection
  51. __system_shrc="$__homerun/system.shrc"
  52. if test -f "$__system_shrc"
  53. then
  54. . "$__system_shrc"
  55. else
  56. ismsys=false
  57. iscygwin=false
  58. iswindows=false
  59. isdarwin=false
  60. isfreebsd=false
  61. isbsd=false
  62. islinux=false
  63. # $OSTYPE is another choice. which is better?
  64. # NOTE: sh on FreeBSD does not define OSTYPE
  65. case `uname` in
  66. MINGW*) ismsys=true ;;
  67. CYGWIN*) iscygwin=true ;;
  68. Darwin*) isdarwin=true ;;
  69. FreeBSD*) isfreebsd=true ;;
  70. Linux*) islinux=true ;;
  71. esac
  72. ($ismsys || $iscygwin) && iswindows=true
  73. # is this true?
  74. ($isdarwin || $isfreebsd) && isbsd=true
  75. # dump system detection result
  76. cat <<__EOC__ >"$__system_shrc"
  77. #!/bin/sh
  78. # $__system_shrc
  79. ismsys=$ismsys
  80. iscygwin=$iscygwin
  81. iswindows=$iswindows
  82. isdarwin=$isdarwin
  83. isfreebsd=$isfreebsd
  84. isbsd=$isbsd
  85. islinux=$islinux
  86. __EOC__
  87. fi
  88. $ismsys && export HOSTNAME
  89. # adhoc fix for ansible on cygwin
  90. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  91. if $iscygwin
  92. then
  93. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  94. fi
  95. ##########################
  96. # Terminal setups
  97. if ! $iswindows && null type stty
  98. then
  99. stty stop undef # unbind C-s to stop displaying output
  100. # stty erase '^h'
  101. fi
  102. # Zsh specific preferences
  103. # http://www.clear-code.com/blog/2011/9/5.html
  104. if $inzsh
  105. then
  106. bindkey -e
  107. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  108. autoload compinit; compinit
  109. # supress cycle by tab
  110. unsetopt auto_menu
  111. # unsetopt correct
  112. setopt complete_aliases
  113. setopt auto_list
  114. setopt bash_auto_list
  115. setopt magic_equal_subst
  116. setopt list_types
  117. # what is the difference of these two?
  118. setopt auto_param_slash
  119. setopt mark_dirs
  120. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  121. zstyle ':completion:*' format '%B%d%b'
  122. zstyle ':completion:*' group-name ''
  123. zstyle ':completion:*' use-cache yes
  124. # zstyle ':completion:*:cd:*' tag-order local-directories
  125. zstyle ':completion:*' completer _complete _bash_completions \
  126. _history
  127. # zstyle ':completion:*:*:cd:*' completer
  128. zstyle ':completion:*' accept-exact-dirs true
  129. zstyle ':completion:*' special-dirs true
  130. autoload colors; colors
  131. # autoload -Uz promptinit
  132. # promptinit
  133. # prompt walters
  134. setopt hist_ignore_dups
  135. setopt hist_ignore_all_dups
  136. setopt hist_save_no_dups
  137. setopt extended_history
  138. setopt share_history
  139. setopt append_history
  140. HISTFILE=$HOME/.zsh-history
  141. HISTSIZE=100000
  142. SAVEHIST=100000
  143. setopt prompt_subst
  144. setopt interactive_comments
  145. fi
  146. ######################
  147. # Print welcome messages
  148. command -v fortune >/dev/null && {
  149. if command -v cowsay >/dev/null
  150. then
  151. fortune | cowsay
  152. echo
  153. fortune -o | cowsay
  154. echo
  155. else
  156. fortune
  157. echo
  158. fortune -o
  159. echo
  160. fi
  161. }
  162. if null type figlet && null type lolcat
  163. then
  164. hostname -s | figlet | lolcat
  165. fi
  166. uname -a
  167. $iswindows && alias tty="echo cmd.exe"
  168. echo TERM $TERM with $(tput colors) colors using $(tty)
  169. echo umask: `umask -S`
  170. echo
  171. __safe_run w yuk
  172. # if null type tmux
  173. # then
  174. # echo
  175. # echo tmux sessions:
  176. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  177. # echo
  178. # fi
  179. # if test -n "$TMUX"
  180. # then
  181. # tmux display -p \
  182. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  183. # 2>/dev/null
  184. # echo
  185. # fi
  186. if test -n "$__MY_DTACH"
  187. then
  188. echo
  189. echo DSession: Current Session: "`basename "$__MY_DTACH"`"
  190. echo DSession: Press C-^ to Exit.
  191. true
  192. fi
  193. i(){
  194. w
  195. ss -lnp
  196. ps aufx
  197. df -h
  198. top -b -d 1 -n 1
  199. top -b -d 1 -n 1 -a
  200. dstat -taf 1 10
  201. }
  202. ###################################
  203. # some aliases and functions
  204. # __func_name: never used interactively
  205. # _func_name: usually not used interactively
  206. __safe_alias(){
  207. # __safe_alias <name>=<command>
  208. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  209. test -n "$_bin" && \
  210. null type $_bin && \
  211. alias "$1"
  212. }
  213. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  214. # color prefs
  215. if $gnu_coreutils
  216. then
  217. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  218. # gnu coreutils LS_COLORS is used
  219. null type dircolors && eval `dircolors`
  220. _coloroption=" --color=auto"
  221. else
  222. # export LSCOLORS=gxfxcxdxbxegedabagacad
  223. export LSCOLORS=DxGxcxdxCxegedabagacad
  224. export CLICOLOR=1
  225. fi
  226. alias ls="ls -hCF${_coloroption}${_timeoption}"
  227. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  228. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  229. _timeformat_num="%Y%m%d%H%M%S"
  230. alias datenum="date +$_timeformat_num"
  231. alias less="less -FX"
  232. __safe_alias em="emacs -nw"
  233. test -n "$_VI_ALT" && alias vi=$_VI_ALT
  234. alias pstree="LANG=C pstree"
  235. alias cp="cp -v"
  236. alias mv="mv -v"
  237. alias rm="rm -v"
  238. alias mkdir="mkdir -v"
  239. $gnu_coreutils && alias rmdir="rmdir -v"
  240. alias psaux="ps auxww"
  241. alias modest="ionice -c 2 -n 7 nice -n 19"
  242. alias e=exec
  243. __safe_alias e3=e3em
  244. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  245. alias po=popd
  246. alias pu=pushd
  247. __safe_alias sudoe="sudoedit"
  248. __safe_alias make="nice make"
  249. __safe_alias brew="nice brew"
  250. __safe_alias gcc="nice gcc"
  251. __safe_alias go="nice go"
  252. __safe_alias git="nice git"
  253. __safe_alias javac="nice javac -J-Duser.language=en"
  254. __safe_alias ansible-playbook="nice ansible-playbook"
  255. alias rand="echo \$RANDOM"
  256. alias pycalc="python -i -c 'from math import *' "
  257. __safe_alias py3=python3
  258. __safe_alias py2=python2
  259. __safe_alias ipy=ipython
  260. __safe_alias ipy3=ipython3
  261. __safe_alias ipy2=ipython2
  262. __safe_alias pip="echo Use pipenv! 1>&2; false"
  263. __safe_alias pip2="echo Use pipenv! 1>&2; false"
  264. __safe_alias pip3="echo Use pipenv! 1>&2; false"
  265. __safe_alias rl=rlwrap
  266. __safe_alias igosh=gosh-rl
  267. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  268. # SHELL is set to be /bin/zsh
  269. if $inbash
  270. then
  271. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  272. elif $inzsh
  273. then
  274. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  275. else
  276. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  277. fi
  278. # alias mytime="date +%Y%m%d-%H%M%S"
  279. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  280. # some extra utilities
  281. __safe_alias mpg123="mpg123 -C -v --title"
  282. #export PLAYER="mpg123 -C -v --title"
  283. __safe_alias screen="screen -e^z^z"
  284. #alias zcd="cd \`zenity --file-selection --directory\`"
  285. __safe_alias gtags="gtags --verbose"
  286. __safe_alias htags="htags --xhtml --symbol --line-number \
  287. --frame --alphabet --verbose"
  288. __safe_alias au=aunpack
  289. # __safe_alias lv="lv|less"
  290. __safe_alias rs="rsync --progress --itemize-changes --compress"
  291. __safe_alias vagr=vagrant
  292. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  293. if $iscygwin
  294. then
  295. __my_wget_options=" --no-check-certificate"
  296. __safe_alias wget="wget $__my_wget_options"
  297. fi
  298. if $isdarwin
  299. then
  300. alias updatedb="LC_ALL=C updatedb"
  301. # do not use locate installed by macports
  302. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  303. fi
  304. # somehow not work
  305. # typeset -ga chpwd_functions
  306. # chpwd_functions+=pwd
  307. # chpwd(){
  308. # pwd
  309. # }
  310. cd(){
  311. builtin cd "$@" && pwd
  312. }
  313. root(){
  314. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  315. then
  316. cd "`git rev-parse --show-toplevel`"
  317. else
  318. cd /
  319. fi
  320. }
  321. __find_latest_vimdir(){
  322. vimdir=/usr/share/vim
  323. if test -d "$vimdir"
  324. then
  325. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  326. else
  327. echo ""
  328. fi
  329. }
  330. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  331. do
  332. test -n "$f" || continue
  333. f="$f/macros/less.sh"
  334. test -f $f && alias vl=$f && break
  335. done
  336. __safe_alias pa="pacman --color=always"
  337. __safe_alias pa="pacmatic --color=always"
  338. __safe_alias pa="pacapt"
  339. __safe_alias yt=yaourt
  340. # variable for yaourt
  341. null type pacmatic && export PACMAN="pacmatic"
  342. __safe_alias cower="cower --color=auto"
  343. __my_pacman_update_mirrorlist_with_reflector(){
  344. f=/etc/pacman.d/mirrorlist
  345. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  346. if test -z "$cmd"
  347. then
  348. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  349. fi
  350. echo ">>> $cmd ..." 1>&2
  351. sudo sh -c "$cmd" && cat $f
  352. }
  353. null type reflector && test -d /etc/pacman.d && \
  354. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  355. null type apt-get && {
  356. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  357. apt-get update --yes && apt-get upgrade --yes'"
  358. alias aptin="apt-get install"
  359. alias aptsearch="apt-cache search"
  360. alias aptshow="apt-cache show"
  361. }
  362. null type port && {
  363. alias port="port -v"
  364. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  365. port -v upgrade outdated'"
  366. }
  367. if $iscygwin
  368. then
  369. null type windate || \
  370. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  371. # alias cygsu="cygstart /cygwinsetup.exe"
  372. fi
  373. mkpatch(){
  374. if test $# -eq 0
  375. then
  376. echo "usage: mkpatch <olddir> <newdir>"
  377. elif ! test -d "$1"
  378. then
  379. echo "mkpatch: $1 is not a directory"
  380. elif ! test -d "$2"
  381. then
  382. echo "mkpatch: $2 is not a directory"
  383. else
  384. diff -Naur "$1" "$2"
  385. fi
  386. }
  387. __sdcv_less(){
  388. command sdcv -n "$@" | less --quit-if-one-screen
  389. }
  390. command -v sdcv >/dev/null && alias dict=__sdcv_less
  391. __safe_alias g="git "
  392. $isdarwin && $inbash && \
  393. . /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-completion.bash
  394. if null type _git && $inbash
  395. then
  396. # enable programmable completion for g
  397. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  398. || complete -o default -o nospace -F _git g
  399. fi
  400. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  401. __safe_alias m=gitmemo
  402. #alias setup.py3="sudo python3 setup.py install --record files.txt"
  403. randomstr(){
  404. len=$1
  405. test -z "$len" && len=8
  406. uuidgen | tr -d - | cut -c 1-len
  407. }
  408. datestr(){
  409. # datestr YYYYMMDDhhmmss
  410. if test -z "$1" || test "$1" = "-h"
  411. then
  412. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  413. return 1
  414. fi
  415. # actual format for date command
  416. dfmt="`echo "$1" | \
  417. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  418. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  419. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  420. date +"$dfmt"
  421. }
  422. # ssh(){
  423. # # __my_terminal_title ssh
  424. # command ssh "$@"
  425. # }
  426. __ssh_with_cd(){
  427. # __ssh_with_cd <host> <directory> [<arg> ...]
  428. if test -z "$2"
  429. then
  430. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  431. return 1
  432. fi
  433. host="$1"
  434. shift
  435. dir="$1"
  436. shift
  437. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  438. }
  439. memo(){
  440. if test -z "$1"
  441. then
  442. _memo="memo.txt"
  443. else
  444. _memo="$1/memo.txt"
  445. fi
  446. $EDITOR "$_memo"
  447. if test -z "`cat "$_memo"`"
  448. then
  449. echo "$_memo is empty. Removing."
  450. rm "$_memo"
  451. fi
  452. }
  453. now(){
  454. ___tformat="%Y/%m/%d %H:%M:%S %z"
  455. cal
  456. REPLY=
  457. printf "\\r`date "+${___tformat}"`"
  458. read -t 1
  459. while test $? -ne 0
  460. do
  461. printf "\\r`date "+${___tformat}"`"
  462. read -t 1
  463. done
  464. }
  465. s(){
  466. if git rev-parse --git-dir >/dev/null 2>&1
  467. then
  468. echo ">> git grep -n $@" 1>&2
  469. git grep -n "$@"
  470. elif which ag >/dev/null 2>&1
  471. then
  472. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  473. ag --pager="$PAGER" "$@"
  474. elif which ack >/dev/null 2>&1
  475. then
  476. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  477. ack --pager="$PAGER" "$@"
  478. else
  479. echo \
  480. ">> find . " \
  481. "-path '*/.git' -prune -o" \
  482. "-path '*/.svn' -prune -o" \
  483. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  484. if test $# -eq 0
  485. then
  486. echo "No search word given." 1>&2
  487. return 1
  488. fi
  489. find . \
  490. -path '*/.git' -prune -o \
  491. -path '*/.svn' -prune -o \
  492. -type -f -exec grep -nH -e --color=always "$@" {} + \
  493. | $PAGER
  494. fi
  495. }
  496. MYMANPATH='/usr/lib/erlang/man'
  497. if $inbash || $inzsh
  498. then
  499. man(){
  500. env \
  501. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  502. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  503. LESS_TERMCAP_me=$(printf "\e[0m") \
  504. LESS_TERMCAP_se=$(printf "\e[0m") \
  505. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  506. LESS_TERMCAP_ue=$(printf "\e[0m") \
  507. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  508. MANPATH="`manpath`:$MYMANPATH" \
  509. man "$@"
  510. }
  511. fi
  512. netwait(){
  513. while ! ping -c 1 -t 1 example.com
  514. do
  515. true
  516. done
  517. echo network works.
  518. }
  519. __realpath(){
  520. if type realpath >/dev/null 2>&1
  521. then
  522. command realpath "$@"
  523. else
  524. while ! test -d $1
  525. do
  526. shift
  527. done
  528. (command cd "$d" && echo "$PWD")
  529. # local d="$OLDPWD"
  530. # command cd "$1"
  531. # echo "$PWD"
  532. # command cd "$d"
  533. fi
  534. }
  535. if $isdarwin
  536. then
  537. # I want to use env -u, but darwin env does not provide this option
  538. null type tmux && alias tmux='SHLVL= tmux'
  539. else
  540. null type tmux && alias tmux='env -u SHLVL tmux'
  541. fi
  542. tx(){
  543. tmux start-server
  544. if test -z "$1"
  545. then
  546. echo "usage: tx [<session_name>]"
  547. tmux list-sessions
  548. elif test -z "$TMUX"
  549. then
  550. # -A: attach if already exists
  551. # tmux new-session -A -c "$HOME" -s "$1"
  552. tmux new-session -A -s "$1"
  553. else
  554. # create new session if not exists yet
  555. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  556. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  557. tmux switch-client -t "$1"
  558. fi
  559. }
  560. __dsession(){
  561. # dt [-h] [<name>] [<command ...>]
  562. __dtach_dir="${TMP}/dtach"
  563. mkdir -p "${__dtach_dir}"
  564. if test -n "${__MY_DTACH}"
  565. then
  566. # if already in dtach session print current session
  567. soc_name="`basename "$__MY_DTACH"`"
  568. echo "Current session: ${soc_name}"
  569. fi
  570. if test -z "$1"
  571. then
  572. # if no arg given show list of sessions
  573. echo "Usage: ds [<session>]"
  574. echo "Sessions:"
  575. ls "${__dtach_dir}"
  576. return 0
  577. elif test "$1" = "-h"
  578. then
  579. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  580. return 1
  581. fi
  582. # set socket name
  583. soc_name="${__dtach_dir}/$1"
  584. shift
  585. if test -n "$__MY_DTACH"
  586. then
  587. echo "dtach session cannot be nested." 1>&2
  588. return 1
  589. elif test -S "$soc_name"
  590. then
  591. dtach -a "$soc_name" -e ^^
  592. elif test -e "$soc_name"
  593. then
  594. echo "dt: File named $soc_name already exists."
  595. return 1
  596. elif test -z "$1"
  597. then
  598. # if no command given invoke current shell
  599. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  600. # echo "dt: Socket named $soc_name not exists and no command specified."
  601. # return 1
  602. else
  603. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  604. fi
  605. }
  606. null type dtach && alias ds=__dsession
  607. scr(){
  608. test -n "$1" && pf="${1}-"
  609. ___tformat="%Y%m%d-%H%M%S%z"
  610. ___file="${PWD}/${pf}`date +${___tformat}`.script"
  611. __MY_SCRIPT=${___file} script ${___file} "$@"
  612. }
  613. dtscr(){
  614. # dtscr <command ...>
  615. if test -z "$1"
  616. then
  617. echo "dtscr: usage: dtscr <command ...>"
  618. return 1
  619. fi
  620. ___cmdstr="`echo $@ | tr ' ' +`"
  621. ___tformat="%Y%m%d-%H%M%S%z"
  622. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  623. ___scr_file="${HOME}/${___name}.script"
  624. ___dt_dir="${TMP}/dtscr"
  625. mkdir -p "$___dt_dir"
  626. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  627. # echo $_name
  628. # echo $_file
  629. }
  630. mcrypt_stream(){
  631. test $# -eq 2 || return 1
  632. case $1 in
  633. en)
  634. mcrypt --key $2 | base64 ;;
  635. de)
  636. base64 -d | mcrypt -d --key $2 ;;
  637. esac
  638. }
  639. gpg_stream(){
  640. test $# -eq 2 || return 1
  641. case $1 in
  642. en)
  643. gpg --passphrase $2 -c --batch |base64 ;;
  644. de)
  645. base64 -d|gpg --passphrase $2 -d --batch ;;
  646. esac
  647. }
  648. dgpg(){
  649. if test "$1" = help || test -z "$2"
  650. then
  651. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  652. return
  653. fi
  654. ___srcs="$2"
  655. ___dsts="$3"
  656. test -z "$___dsts" && ___dsts="${___srcs}.out"
  657. ___pw=
  658. echo -n "dgpg pw: "
  659. read -s ___pw
  660. echo ""
  661. test -z "$___pw" && return 1
  662. for f in *${___srcs}
  663. do
  664. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  665. echo -n "Processing $f to $___d..."
  666. if test -d "$f"
  667. then
  668. echo "`printf 'failed (%s is directory)' $f`"
  669. elif test -f "$___d"
  670. then
  671. echo "`printf 'failed (%s is already exists)' $___d`"
  672. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  673. then
  674. echo "done"
  675. else
  676. echo "failed"
  677. test -f "$___d" && rm "$___d"
  678. fi
  679. done
  680. }
  681. alias enst="gpg_stream en"
  682. alias dest="gpg_stream de"
  683. showinfo(){
  684. echo "Japanese letters are 表示可能"
  685. __safe_run diskinfo
  686. ! $isdarwin && test -n "${DISPLAY}" && {
  687. __safe_run xrandr | \grep --color=never ^Screen
  688. }
  689. $iswindows || __safe_run finger $USER
  690. LANG=C __safe_runc id
  691. __safe_run xset q
  692. }
  693. x(){
  694. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  695. #mkdir -p ~/.var/log
  696. # nohup startx >~/.var/log/xorg.log 2>&1 &
  697. # exit
  698. exec startx
  699. else
  700. echo "X cant be started! Another X is already running?" 1>&2
  701. fi
  702. }
  703. bak(){
  704. for file in "$@"
  705. do
  706. cp -v ${file} ${file}.bak
  707. done
  708. }
  709. di(){
  710. if null type git
  711. then
  712. git --git-dir= diff "$@"
  713. ___diffcmd="git --git-dir= diff"
  714. else
  715. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  716. then
  717. ___diffcmd=colordiff
  718. else
  719. ___diffcmd=diff
  720. fi
  721. ${___diffcmd} -u "$@" | ${PAGER}
  722. fi
  723. }
  724. tb(){
  725. __datenum=`date +%Y%m%d-%H%M%S`
  726. __tb="$HOME/.var/tb/$__datenum"
  727. mkdir -p "$__tb"
  728. mv "$@" "$__tb"
  729. }
  730. mkdd(){
  731. _d=`date +%Y%m%d-%H%M%S` && \
  732. mkdir -p "$_d"
  733. }
  734. mkcd(){
  735. if test -z "$1"
  736. then
  737. echo "mkcd: usage: mkcd <dir>"
  738. return 1
  739. elif test -d "$1"
  740. then
  741. echo "Dir \"$1\" already exists."
  742. else
  743. mkdir -p "$1"
  744. echo "Dir \"$1\" created."
  745. fi
  746. cd "$1"
  747. }
  748. mkcdd(){
  749. # make and change date directory
  750. _d=`date +%Y%m%d-%H%M%S` && \
  751. mkcd "$_d"
  752. }
  753. if test -n "$TMUX" && null type reattach-to-user-namespace
  754. then
  755. alias pbpaste="reattach-to-user-namespace pbpaste"
  756. alias pbcopy="reattach-to-user-namespace pbcopy"
  757. fi
  758. catclip(){
  759. if $iswindows
  760. then
  761. cat /dev/clipboard | tr -d \\r
  762. elif $isdarwin
  763. then
  764. pbpaste
  765. else
  766. xclip -o -selection "clipboard"
  767. fi
  768. }
  769. setclip(){
  770. if test $# -eq 0
  771. then
  772. exec 3<&0
  773. else
  774. exec 3<<__EOF__
  775. `cat "$@"`
  776. __EOF__
  777. fi
  778. if $iswindows
  779. then
  780. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  781. elif $isdarwin
  782. then
  783. pbcopy 0<&3
  784. else
  785. 0<&3 xclip -i -f -selection "primary" | \
  786. xclip -i -f -selection "clipboard"
  787. fi
  788. exec 3<&-
  789. }
  790. open_file(){
  791. if $iscygwin
  792. then
  793. cygstart "$@"
  794. elif $ismsys
  795. then
  796. cmd.exe //c start "" "$@"
  797. elif $isdarwin
  798. then
  799. touch "$@"
  800. open "$@"
  801. elif $islinux
  802. then
  803. touch "$@"
  804. if null type pcmanfm; then
  805. LC_MESSAGES= pcmanfm "$@"
  806. else
  807. LC_MESSAGES= xdg-open "$@" &
  808. fi
  809. else
  810. cat "$@"
  811. fi
  812. }
  813. o(){
  814. if test $# -eq 0
  815. then
  816. open_file .
  817. else
  818. for f in "$@"
  819. do
  820. open_file "$(realpath "$f")"
  821. done
  822. fi
  823. }
  824. convmv_sjis2utf8_test(){
  825. convmv -r -f sjis -t utf8 *
  826. }
  827. convmv_sjis2utf8_notest(){
  828. convmv -r -f sjis -t utf8 * --notest
  829. }
  830. #################################################
  831. ## pastebin services
  832. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  833. sprunge(){
  834. # http://sprunge.us
  835. if test -z "$1"
  836. then
  837. curl -F 'sprunge=<-' http://sprunge.us
  838. else
  839. curl http://sprunge.us/$1
  840. fi
  841. }
  842. dpaste(){
  843. # http://dpaste.de
  844. if test -z "$1"
  845. then
  846. curl -F 'content=<-' https://dpaste.de/api/
  847. echo
  848. else
  849. curl https://dpaste.de/$1/raw/
  850. fi
  851. }
  852. ######################################
  853. ## Prompt Settings
  854. __my_moc_state(){
  855. type mocp >/dev/null 2>&1 || return
  856. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  857. printf "$1" "`mocp -Q %title 2>/dev/null`"
  858. }
  859. __my_parse_svn_branch() {
  860. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  861. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  862. sed -ne 's#^Repository Root: ##p')
  863. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  864. awk '{print $1}'
  865. }
  866. __my_svn_ps1(){
  867. if svn status >/dev/null 2>&1
  868. then
  869. ___svn_branch=$(__my_parse_svn_branch)
  870. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  871. fi
  872. }
  873. __my_battery_status(){
  874. ___dir=/sys/class/power_supply/BAT0
  875. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  876. test -r $___dir/charge_now
  877. then
  878. ___st=$(cat $___dir/status)
  879. ___full=$(cat $___dir/charge_full)
  880. ___now=$(cat $___dir/charge_now)
  881. ___rate=$(expr "$___now" \* 100 / "$___full")
  882. printf "$1" "${___st}:${___rate}%"
  883. fi
  884. }
  885. alias bat='__my_battery_status %s\\n'
  886. __my_ps1_scale(){
  887. if null type stty && ! $ismsys
  888. then
  889. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  890. fi
  891. }
  892. __my_ps1_tmux(){
  893. null type tmux || return $last
  894. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  895. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  896. }
  897. __my_ps1_moc(){
  898. __my_moc_state "[MOC:%s]"
  899. }
  900. for f in /usr/share/git/git-prompt.sh \
  901. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  902. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  903. "`brew --prefix 2>/dev/null`"/etc/bash_completion.d/git-prompt.sh \
  904. /usr/share/git-core/contrib/completion/git-prompt.sh \
  905. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  906. /etc/bash_completion.d/git-prompt \
  907. /opt/local/share/git-core/git-prompt.sh \
  908. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  909. do
  910. if test -r "$f" && ($inbash || $inzsh)
  911. then
  912. . "$f"
  913. break
  914. fi
  915. done
  916. export GIT_PS1_SHOWDIRTYSTATE=t
  917. export GIT_PS1_SHOWUPSTREAM=t
  918. __my_ps1_git(){
  919. null type __git_ps1 || return $last
  920. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  921. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  922. }
  923. __printf_ipaddr(){
  924. # ipaddress <fmt>
  925. type ip >/dev/null 2>&1 || return 1
  926. ___ip=$(LANG=C ip addr show scope global | \
  927. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  928. test -n "$___ip" && printf "$1" $___ip
  929. }
  930. alias addr="__printf_ipaddr '%s'"
  931. __my_ps1_ipaddr(){
  932. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  933. }
  934. __my_ps1_bttry(){
  935. ___bst="$__homerun/batterystatus"
  936. if test -z "$DISPLAY" && ! $iswindows
  937. then
  938. test -f $___bst && ___bstr="$(cat $___bst)"
  939. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  940. echo "[Battery:${___bstr}]"
  941. __my_battery_status %s >$___bst &
  942. fi
  943. }
  944. __my_ps1_memo(){
  945. test -f memo.txt && echo "m:$(echo $(wc -c memo.txt) | cut -f 1 -d " ")"
  946. }
  947. __my_ps1_dirs(){
  948. dirs | wc -l
  949. }
  950. __my_ps1_jobs(){
  951. # __my_ps1_jobs [<num>]
  952. if test -n "$1"
  953. then
  954. jobs="$1"
  955. else
  956. jobs="`jobs | wc -l`"
  957. fi
  958. if test "$jobs" -gt 0
  959. then
  960. echo "JOBS:$jobs"
  961. fi
  962. }
  963. __my_ps1_dollar(){
  964. if test -z "$SHLVL"
  965. then
  966. printf "$1"
  967. else
  968. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  969. fi
  970. }
  971. __my_alert_fail(){
  972. test $laststatus -eq 0 || \
  973. echo "STATUS:${laststatus}"
  974. }
  975. # About ansi escape sequences
  976. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  977. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  978. if $inbash || $inzsh
  979. then
  980. if $inzsh
  981. then
  982. __attr_beg=$'%{\033['
  983. __attr_end='m%}'
  984. else
  985. __attr_beg='\[\033['
  986. __attr_end='m\]'
  987. fi
  988. __color_default="${__attr_beg}0${__attr_end}"
  989. __color_black="${__attr_beg}0;30${__attr_end}"
  990. __color_red="${__attr_beg}0;31${__attr_end}"
  991. __color_green="${__attr_beg}0;32${__attr_end}"
  992. __color_yellow="${__attr_beg}0;33${__attr_end}"
  993. __color_blue="${__attr_beg}0;34${__attr_end}"
  994. __color_magenta="${__attr_beg}0;35${__attr_end}"
  995. __color_cyan="${__attr_beg}0;36${__attr_end}"
  996. __color_white="${__attr_beg}0;37${__attr_end}"
  997. __color_light_black="${__attr_beg}1;30${__attr_end}"
  998. __color_light_red="${__attr_beg}1;31${__attr_end}"
  999. __color_light_green="${__attr_beg}1;32${__attr_end}"
  1000. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  1001. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1002. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  1003. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1004. __color_light_white="${__attr_beg}1;37${__attr_end}"
  1005. __color_bg_black="${__attr_beg}40${__attr_end}"
  1006. __color_bg_red="${__attr_beg}41${__attr_end}"
  1007. __color_bg_green="${__attr_beg}42${__attr_end}"
  1008. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1009. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1010. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1011. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1012. __color_bg_white="${__attr_beg}47${__attr_end}"
  1013. __attr_underline="${__attr_beg}4${__attr_end}"
  1014. __attr_reverse="${__attr_beg}7${__attr_end}"
  1015. __attr_bold="${__attr_beg}1${__attr_end}"
  1016. fi
  1017. # NOTE: tput is another easy way to set colors and background
  1018. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1019. # color blue.
  1020. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1021. if test "$TERM" != dumb
  1022. then
  1023. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1024. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1025. # color for ::
  1026. if test -z "$_HOSTCOLOR_1"
  1027. then
  1028. # default color used by tmux status line
  1029. _HOSTCOLOR_1=green
  1030. fi
  1031. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1032. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1033. __my_cdef="$__color_default"
  1034. fi
  1035. if $inbash
  1036. then
  1037. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1038. elif $inzsh
  1039. then
  1040. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1041. fi
  1042. __my_ps1_info1(){
  1043. # first line of PS1
  1044. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1045. }
  1046. test -n "$__MY_SCRIPT" && \
  1047. __my_ps1_str_scr="SCR"
  1048. test -n "$SSH_CONNECTION" && \
  1049. __my_ps1_str_ssh="SSH"
  1050. test -n "$__MY_DTACH" && \
  1051. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1052. __my_ps1_info2(){
  1053. # second line of PS1
  1054. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1055. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1056. | sed -e 's/ /|/g'
  1057. }
  1058. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1059. __my_ps1_save_pos="\[\033[s\]"
  1060. __my_ps1_restore_pos="\[\033[u\]"
  1061. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1062. __my_ps1_move_15left="\[\033[15D\]"
  1063. # collapse when command line is too long and try to write over this string
  1064. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1065. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1066. if $inzsh
  1067. then
  1068. PROMPT="\
  1069. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1070. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1071. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1072. elif $inbash
  1073. then
  1074. PS1="\
  1075. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1076. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1077. else
  1078. true
  1079. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1080. fi
  1081. ###################################
  1082. # set header and titles
  1083. __my_set_header_line(){
  1084. # save current position
  1085. printf "\033[s"
  1086. # move to 0,0
  1087. printf "\033[0;0H"
  1088. # clear curent to eol
  1089. printf "\033[K"
  1090. # inverse color
  1091. printf "\033[7m"
  1092. printf "$1"
  1093. # restore color
  1094. printf "\033[0m"
  1095. # restore saved position
  1096. printf "\033[u"
  1097. }
  1098. __my_set_screen_name(){
  1099. # set window name
  1100. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1101. then
  1102. echo -ne "\033k$1\033\\"
  1103. fi
  1104. }
  1105. __my_set_title(){
  1106. case $TERM in
  1107. (rxvt*|xterm*|aterm|screen*)
  1108. test -t 1 &&
  1109. test -z "$EMACS" &&
  1110. echo -n -e "\033]0;$1\007"
  1111. ;;
  1112. esac
  1113. }
  1114. if test -n "$TMUX"
  1115. then
  1116. # running tmux locally
  1117. __terminal_title="\$(basename \${PWD})"
  1118. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1119. then
  1120. # ssh connect from tmux terminal
  1121. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1122. else
  1123. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1124. fi
  1125. if $inzsh
  1126. then
  1127. precmd(){
  1128. laststatus=$?
  1129. eval __my_set_title ${__terminal_title}
  1130. }
  1131. else
  1132. if test -n "$PROMPT_COMMAND" && ! expr "$PROMPT_COMMAND" : '.*; *$' >/dev/null
  1133. then
  1134. PROMPT_COMMAND="${PROMPT_COMMAND};"
  1135. fi
  1136. if test -n "$PROMPT_COMMAND"
  1137. then
  1138. PROMPT_COMMAND="laststatus=\$?;${PROMPT_COMMAND}__my_set_title \"${__terminal_title}\";"
  1139. else
  1140. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";"
  1141. fi
  1142. fi
  1143. laststatus=0